host group parameter overrides reformatting YAML values to strings
Status: New   

Priority: Normal   

Assignee:    

Category: Parameters   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.10.0

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Adding an override to a smart class parameter of type YAML from host groups with the value:

---

- Apple

- Orange

- Strawberry

- Mango

 results in the host edit form showing the parameter as:

--- ! '- Apple

  - Orange

  - Strawberry

  - Mango

'

 As a workaround I override it again from host.

For mor complexe yaml example you may found "\n"

Related issues:

Related to Foreman - Bug #11375: Smart class parameters turn YAML to string w... Closed 08/16/2015

Related to Foreman - Bug #14292: Child hostgroup cloning issue with array par... Resolved

History

#1 - 10/23/2015 09:54 AM - Dominic Cleal

- Related to Bug #11375: Smart class parameters turn YAML to string when using a multi line yaml added

#2 - 10/23/2015 09:55 AM - Dominic Cleal

- Description updated

- Category set to Parameters

#3 - 10/30/2015 07:00 AM - Dominic Cleal

- Assignee deleted (Dominic Cleal)

It's a related but definitely different to #11375 it seems.

The UI (app/views/puppetclasses/_class_parameters.html.erb and host_key_with_diagnostic helper) attempts to reverse LookupValue#value - which

it expects to return a hash or array for a YAML parameter - in order to display it in the textbox.  It does this essentially by calling

LookupKey#value_before_type_cast(LookupValue's value) in the helper.
https://projects.theforeman.org/issues/11375


However it retrieves the list of LookupValues applicable to the host by calling Classification::ClassParam (via the value_hash_cache helper).  In

Classification::Base#update_generic_matcher, it calls LookupKey#value_before_type_cast so the value is actually the YAML string rather than the

hash/array.

When this string is passed back, as above, it calls value_before_type_cast but with the YAML string, causing a second level of YAML in the textbox

instead of the original one level.

Changing the behaviour of update_generic_matcher to get .value means further changes in the classification to ensure the ENC output still works (it

attempts to type cast it again I think).

#4 - 10/30/2015 09:18 PM - Hector Elenes

- File after-submit.png added

- File before-submit.png added

I'm seeing this issue in 1.9.2. Attached screenshots. The current workaround is making the parameter overrides in the Puppet Class > Smart Class

Parameter page.

#5 - 11/02/2015 02:55 AM - Dominic Cleal

Hector, your issue is #11375 (due for 1.9.3 tomorrow) as it's just editing/saving of overrides.  This bug is specifically about overriding of a value

inherited from a host group.

#6 - 11/02/2015 09:05 AM - Hector Elenes

Dominic Cleal wrote:

Hector, your issue is #11375 (due for 1.9.3 tomorrow) as it's just editing/saving of overrides.  This bug is specifically about overriding of a value

inherited from a host group.

 Thank you Dominic!

#7 - 12/23/2015 07:01 AM - Kerguillec Paul

Hi Dominic, it's not fixed in RC3 release ?

I have also noticed the related (same ?) issue from "Default Behavior" by editing smart class parameters inside edit parameter class subsection.

#8 - 12/23/2015 07:24 AM - Dominic Cleal

Kerguillec Paul wrote:

Hi Dominic, it's not fixed in RC3 release ?

 No, the issue is marked "New" so is unfixed.

#9 - 03/21/2016 08:07 AM - Dominic Cleal

- Related to Bug #14292: Child hostgroup cloning issue with array parameters added
